/*! Backbone.Rpc - v0.1.1
------------------------------
Build @ 2012-11-15
Documentation and Full License Available at:
http://asciidisco.github.com/Backbone.Rpc/index.html
git://github.com/asciidisco/Backbone.Rpc.git
Copyright (c) 2012 Sebastian Golasch <public@asciidisco.com>

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation
the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the

Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
IN THE SOFTWARE.*/
(function(e,t,n,r,i,s,o){"use strict";typeof r=="object"?i.exports=s(n("underscore"),n("backbone"),n("jquery")):typeof t=="function"&&t.amd?t(["underscore","backbone","jquery"],function(t,n,r){return t=t===o?e._:t,n=n===o?e.Backbone:n,r=r===o?e.$:r,e.Backbone=s(t,n,r)}):e.returnExportsGlobal=s(e._,e.Backbone,e.$)})(this,this.define,this.require,this.exports,this.module,function(e,t,n,r){"use strict";var i=function(t){this.options=t!==r?t:{},this.namespaceDelimiter=t!==r&&t.namespaceDelimiter!==r?t.namespaceDelimiter:this.namespaceDelimiter,this.contentType=t!==r&&t.contentType!==r?t.contentType:this.contentType,e.bindAll(this)},s=t.Model.prototype.constructor,o=t.sync,u={};return i.prototype={options:{},charset:"iso-8859-1",namespace:"",namespaceDelimiter:"/",contentType:"application/json",url:null,responseID:null,exceptions:{404:{code:-1,message:"404"},500:{code:-2,message:"500"},typeMissmatch:{code:-3,message:"Type missmatch"},badResponseId:{code:-4,message:"Bad response ID"},noResponse:{code:-5,message:"No response"},noDefError:{code:-6,message:"No error defined"},renderError:function(e,t){return{code:t!==r?-7:t,message:e?"No error defined":e}}},onSuccess:function(t,n,i){if(e.isFunction(t)===!0){if(i===null||i===r)return this.handleExceptions(this.exceptions.noResponse),this;i!==null&&n!==String(i.id)&&this.handleExceptions(this.exceptions.badResponseId),t.apply(this,[i.result,i.error])}else this.onError(i)},onError:function(e,t){if(t===null||t===r)return this.handleExceptions(this.exceptions.noResponse),this;null!==t.error&&r!==t.error?this.handleExceptions(t.error):this.handleExceptions(this.exceptions.noDefError)},query:function(t,i,s){var o=String((new Date).getTime()),u=null;return this.responseID=o,e.isArray(i)&&e.isString(t)?u=n.ajax({contentType:this.contentType+"; charset="+this.charset,type:"POST",dataType:"json",url:this.url,data:JSON.stringify({jsonrpc:"2.0",method:this.namespace+this.namespaceDelimiter+t,id:o,params:i}),statusCode:{404:e.bind(function(){this.handleExceptions(this.exceptions[404])},this),500:e.bind(function(){this.handleExceptions(this.exceptions[500])},this)},success:e.bind(function(e,t,n){e!==null&&e.error!==r?this.onError(s,e,t,n):this.onSuccess(s,o,e,t,n)},this),error:e.bind(function(e,t,n){e.status!==404&&e.status!==500&&this.onError(s,e,t,n)},this)}):u=this.handleExceptions(this.exceptions.typeMissmatch),u},checkMethods:function(n,i,s,o,a,f,l){var c=null,h=!1,p=null,d=[],v={},m=null;return o=o==="delete"?"remove":o,!e.isArray(s.methods[o])&&!e.isFunction(s.methods[o])?this.handleExceptions(this.exceptions.typeMissmatch):(e.isFunction(s.methods[o])?(e.isString(u[s.get("_rpcId")])||e.each(u[s.get("_rpcId")],function(e,t){s.get(t)!==e&&(v[t]=!0)}),u[s.get("_rpcId")]=s.toJSON(),c=e.bind(s.methods[o],s)(v,a)):c=s.methods[o],e.isArray(c[0])&&(h=!0),h!==!0?(m=e.clone(c),p=m.shift(),m.length>0?e.each(m,function(n){n===""?d.push(""):s instanceof t.Collection?s[n]!==r?e.isFunction(s[n])?d.push(s[n]()):d.push(s[n]):a[n]!==r&&d.push(a[n]):s.get(n)!==r?d.push(s.get(n)):a[n]!==r&&d.push(a[n])}):d=[],n(p,d,f,l)):(e.each(c,function(t){var r=e.clone(t);return p=null,d=[],p=r.shift(),e.each(r,function(e){d.push(s.get(e))}),n(p,d,f,l)}),null))},invoke:function(n,i,s){var o={success:function(t){i.trigger("called:"+n,i,t),s!==r&&e.isFunction(s.success)&&s.success(i,t)},error:function(t,i){t.trigger("error",t,i),t.trigger("error:"+n,t,i),s!==r&&e.isFunction(s.error)&&s.error(t,i)}};return t.sync(n,i,o),this},defaultExceptionHandler:function(e){throw"Error code: "+e.code+" - message: "+e.message},handleExceptions:function(t){var n=e.isFunction(this.options.exceptionHandler)?this.options.exceptionHandler:this.defaultExceptionHandler;return n.call(this,t),this}},t.Rpc=i,t.Model=t.Model.extend({constructor:function(t){this.rpc!==r&&e.isFunction(this.rpc.invoke)===!0&&this.methods!==r&&e.each(this.methods,e.bind(function(t,n){(({read:1,create:1,remove:1,update:1}))[n]!==1&&(this[n]=e.bind(function(e){return this.rpc.invoke(n,this,e),this},this))},this)),s.apply(this,arguments)}}),t.sync=function(n){var i=null,s=function(o,a,f){var l=function(n,i){if(i!==null&&i!==r)return f.error(a,i),this;a instanceof t.Collection&&n!==r&&n!==null&&(typeof n[0]=="object"?e.each(n,function(t,r){t._rpcId=e.uniqueId("rpc_"),n[r]=t,u[t._rpcId]=t}):e.each(n,function(e,t){u[t]=e})),a instanceof t.Model&&n!==r&&n!==null&&(n._rpcId=e.uniqueId("rpc_"),u[n._rpcId]=n);if(n===r||n===null)n=[];a.parsers!==r&&a.parsers[o]!==r&&e.isFunction(a.parsers[o])&&a.parsers[o].apply(a,[n]),f.success(n)},c=function(e){f.error(a,e)};if(a.rpc instanceof n){i=a.rpc,i.url=e.isFunction(a.url)?a.url():a.url,e.isString(a.namespace)===!0&&(i.namespace=a.namespace);if(a.methods===r)throw"Backbone.Rpc Error: No Method(s) given!";return typeof a.params!="object"&&(a.params={}),i.checkMethods(i.query,a.params,a,o,f,l,c)}return s.previous.apply(a,arguments)};return s.previous=o,s}(i),t});